<template>
    <div>
        <q-btn label="Add User" @click="dialog = true" flat/>
        <q-dialog v-model="dialog">
            <div class="bg-base q-pa-md q-gutter-y-lg">
                <div class="text-h6 text-weight-light">Add User To Project</div>
                <q-select
                    filled
                    use-input
                    map-options
                    option-label="username"
                    v-model="model"
                    clearable
                    label="User"
                    :options="options"
                    :rule="[r=> !!r || 'Required']"
                    @filter="filterFunction"

                >
                    <template v-slot:option="scope">
                        <q-item v-bind="scope.itemProps" v-on="scope.itemEvents">
                            <q-item-section>
                                <q-item-label>
                                    {{ scope.opt.username }}
                                </q-item-label>
                                <q-item-label caption>{{ scope.opt.name }}</q-item-label>
                            </q-item-section>
                        </q-item>
                    </template>
                    <template v-slot:no-option>
                        <q-item>
                            <q-item-section class="text-grey">
                                No results
                            </q-item-section>
                        </q-item>
                    </template>
                </q-select>
                <div class="row justify-between">
                    <q-btn label="back" outline @click="dialog = false"/>
                    <q-btn label="Add" icon-right="add" color="primary" :valid="model != null" @click="AddProject"/>
                </div>
            </div>
        </q-dialog>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {UserSafeResponse} from "src/classLibrary/APIModels/core/userSafeResponse";
import {WarnMessage} from "src/classLibrary/Utility";
import {ProjectResponse} from "src/classLibrary/APIModels/core/projectResponse";

@Component
export default class AddUserToProjectDialog extends Vue {
    @Prop() project!: ProjectResponse | null;
    options: UserSafeResponse[] = [];

    dialog = false;

    model: UserSafeResponse | null = null;

    async AddProject() {
        if (this.model == null) {
            return;
        }
        const token = await this.$auth.CoreToken;
        const pid = this.PersistentStore.StoreValue.project;
        const r = await this.$coreApi.QPost(`Project/${pid}/add/${this.model?.id}`, null, token);
        if (r.isSome()) {
            console.error(r.unwrap());
            this.$q.notify(WarnMessage("Failed to add user to project"))
            return;
        }
        this.dialog = false;
        this.$emit('submit')

    }

    async filterFunction(search: string, done: Function) {
        if (search.IsEmpty()) {
            done();
            return;
        }
        const coreToken = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<UserSafeResponse[]>(`User?search=${search}`, null, coreToken);
        if (r.isErr()) {
            this.$q.notify(WarnMessage('Failed to get users'))
            done();
            return;
        }
        this.options = r.unwrap().Where(x => !this.project?.member.Map(m => m.id).Has(x.id));
        done();
        return;
    }

}
</script>

<style lang='scss' scoped>

</style>
